
-- Cirque De La Lune Database
--------------------
-- Script revised by L. Pollacia 03/2019
--------------------
--------------------
-- DROP TABLES for multiple runs
--------------------
-- DROP TABLE CIR_EVENT_has_CUSTOMERS;
-- DROP TABLE CIR_EVENT_has_performers;
-- DROP TABLE CIR_EVENT;
-- DROP TABLE CIR_PERFORMER;
-- DROP TABLE CIR_SPECIALTY;
-- DROP TABLE CIR_TEAM;
-- DROP TABLE CIR_CUSTOMER;
-- DROP TABLE CIR_LOCATION;
-- DROP TABLE CIR_SHOW;


--------------------
-- CREATE TABLES
--------------------
-- CIR_SHOW table
CREATE TABLE CIR_SHOW (
showID      NUMBER(4),
showName    VARCHAR2(25) CONSTRAINT show_showname_uk UNIQUE,
showTheme   VARCHAR2(45),
showEstDate DATE,
showExpDate DATE,
-- Table-level constraints
CONSTRAINT show_showid_pk PRIMARY KEY (showid));

-- Populate CIR_SHOW
INSERT INTO CIR_show VALUES ( 
10, 'Symphonia', 'Orcestral music. Jewel colors.', 
TO_DATE('08-OCT-2010', 'DD-MON-YYYY'), TO_DATE('11-OCT-2018', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES (20, 'Mana', 'Cool colors, magenta, and yellow.',
TO_DATE('12-OCT-2014', 'DD-MON-YYYY'), TO_DATE('12-OCT-2018', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
30, 'Lune', 'Cool colors, white, black, and black light',
TO_DATE('07-OCT-2016', 'DD-MON-YYYY'), TO_DATE('10-OCT-2019', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
40, 'Eclipse', 'Bright warm colors, white, and black.',
TO_DATE('13-OCT-2017', 'DD-MON-YYYY'), TO_DATE('10-OCT-2019', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
50, 'Gravity', 'colidescope effect colors',
TO_DATE('12-OCT-2018', 'DD-MON-YYYY'), TO_DATE('10-OCT-2020', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
60, 'Mistic', 'Smoke and mirrors',
TO_DATE('01-MAR-2019', 'DD-MON-YYYY'), TO_DATE('04-MAR-2021', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
70, 'Savannah', 'African and Australian savannahs',
TO_DATE('11-OCT-2019', 'DD-MON-YYYY'), TO_DATE('07-OCT-2021', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
80, 'Peak', 'Tallest mountains on Earth',
TO_DATE('06-MAR-2020', 'DD-MON-YYYY'), TO_DATE('03-MAR-2022', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
90, 'Alien', '',
TO_DATE('09-OCT-2020', 'DD-MON-YYYY'), TO_DATE('06-OCT-2022', 'DD-MON-YYYY') );

INSERT INTO CIR_show VALUES ( 
100, 'Liquid', '',
TO_DATE('05-MAR-2018', 'DD-MON-YYYY'), TO_DATE('02-MAR-2023', 'DD-MON-YYYY') );



--------------------
-- CIR_LOCATION
CREATE TABLE CIR_LOCATION (
locationID      NUMBER(4),
locationName    VARCHAR2(30) CONSTRAINT location_locationname_uk UNIQUE,
locationStreetNumber VARCHAR2(10) CONSTRAINT location_locstreetnumber_nn NOT NULL,
locationStreetAddress VARCHAR2(45) CONSTRAINT location_locstreetaddress_nn NOT NULL,
locationCity    VARCHAR2(45) CONSTRAINT location_locationcity_nn NOT NULL,
locationState   VARCHAR2(25) CONSTRAINT location_locationstate_nn NOT NULL,
locationPhone   VARCHAR2(10) CONSTRAINT location_locationphone_uk UNIQUE,
locationEmail   VARCHAR2(45) CONSTRAINT location_locationemail_uk UNIQUE,
locationCapacity NUMBER(6),
-- Table-level constraints
CONSTRAINT location_locationid_pk PRIMARY KEY (locationid));

-- POPULATE CIR_LOCATION
INSERT INTO CIR_location VALUES ( 101, 'Atlantic Station', '1234', '20th Street', 'Atlanta', 'Georgia', '6786786789', 'atlanta@cirquelune.com', 400 );
INSERT INTO CIR_location VALUES ( 202, 'Universal Citywalk', '6000', 'Universal Blvd', 'Orlando', 'Florida', '3213213210', 'orlando@cirquelune.com', 350 );
INSERT INTO CIR_location VALUES ( 303, 'Bayfront Park Amphitheatre', '301', 'Biscayne Blvd', 'Miami', 'Florida', '3053053056', 'miami@cirquelune.com', 350 );
INSERT INTO CIR_location VALUES ( 404, 'Discovery Green', '1500', 'McKinney St', 'Houston', 'Texas', '7137137134', 'houston@cirquelune.com', 500 );
INSERT INTO CIR_location VALUES ( 505, 'The Magic Castle ', '7001', 'Franklin Avenue', 'Hollywood', 'California', '2132132134', 'la@cirquelune.com', 500 );
INSERT INTO CIR_location VALUES ( 606, 'The Venetian', '3355', 'Neon Lights Avenue', 'Las Vegas', 'Nevada', '7027027023', 'vegas@cirquelune.com', 400 );
	
--------------------
-- CIR_CUSTOMER
CREATE TABLE CIR_CUSTOMER (
customerID      NUMBER(9),
customerFirstName  VARCHAR2(25),
customerLastName   VARCHAR2(25),
customerPhone   VARCHAR2(10) CONSTRAINT customer_customerphone_uk UNIQUE,
customerEmail   VARCHAR2(45) CONSTRAINT customer_customeremail_uk UNIQUE,
-- Table-level constraints
CONSTRAINT customer_customerid_pk PRIMARY KEY (customerid));

-- POPULATE CIR_CUSTOMER
INSERT INTO CIR_customer VALUES (
1, 'Martie', 'Lowin', '6167203051', 'mlowin0@accuweather.com');
INSERT INTO CIR_customer VALUES (
2, 'Marge', 'Littrick', '2713152253', 'mlittrick1@hubpages.com');
INSERT INTO CIR_customer VALUES (
3, 'Karoly', 'Potten', '6141095514', 'kpotten2@i2i.jp');
INSERT INTO CIR_customer VALUES (
4, 'Astrid', 'Dagworthy', '9713661363', 'adagworthy3@archive.org');
INSERT INTO CIR_customer VALUES (
5, 'Jacinda', 'Ffoulkes', '7614315978', 'jffoulkes4@google.fr');
INSERT INTO CIR_customer VALUES (
6, 'Shelba', 'Bidnall', '5048328115', 'sbidnall5@wsj.com');
INSERT INTO CIR_customer VALUES (
7, 'Mack', 'Ribou', '6469846018', 'mribou6@xing.com');
INSERT INTO CIR_customer VALUES (
8, 'Sarene', 'Haughian', '9086399006', 'shaughian7@networksolutions.com');
INSERT INTO CIR_customer VALUES (
9, 'Verne', 'Breakey', '6408512926', 'vbreakey8@bravesites.com');
INSERT INTO CIR_customer VALUES (
10, 'Son', 'Hegarty', '5131677928', 'shegarty9@spotify.com');
INSERT INTO CIR_customer VALUES (
11, 'Maynord', 'Scarbarrow', '8905892862', 'mscarbarrowrn@cyberchimps.com');
INSERT INTO CIR_customer VALUES (
12, 'Lotti', 'Farish', '3288740916', 'lfarishro@miitbeian.gov.cn');
INSERT INTO CIR_customer VALUES (
13, 'Brigit', 'Cashell', '6088496481', 'bcashellrp@skyrock.com');
INSERT INTO CIR_customer VALUES (
14, 'Cherrita', 'Odams', '2087487846', 'codamsrq@webeden.co.uk');
INSERT INTO CIR_customer VALUES (
15, 'Kimmie', 'Gallaher', '1747689652', 'kgallaherrr@redcross.org');


--------------------
-- CIR_TEAM
CREATE TABLE CIR_TEAM (
teamID     NUMBER(4),
teamName   VARCHAR2(25) CONSTRAINT team_teamname_uk UNIQUE,
teamTheme  VARCHAR2(25),
CONSTRAINT team_teamid_pk PRIMARY KEY (teamid));

-- POPULATE CIR_TEAM
INSERT INTO CIR_team VALUES ( 
100, 'Chimera', 'Alchemy' );
INSERT INTO CIR_team VALUES ( 
200, 'Unicorn', 'Mystery');
INSERT INTO CIR_team VALUES ( 
300, 'Griffin', 'Courage');
INSERT INTO CIR_team VALUES ( 
400, 'Dragon', 'Power');
INSERT INTO CIR_team VALUES ( 
500, 'Pheonix', 'Resurection');
INSERT INTO CIR_team VALUES ( 
600, 'Mermaid', 'Illusion');
INSERT INTO CIR_team VALUES ( 
700, 'Siren', 'Confusion');
INSERT INTO CIR_team VALUES ( 
800, 'Hydra', 'Immortality' );

--------------------
-- CIR_SPECIALTY
CREATE TABLE CIR_SPECIALTY (
specialtyID     NUMBER(4),
specialtyName   VARCHAR2(25) CONSTRAINT specialty_specialtyname_uk UNIQUE,
specialtyType   VARCHAR2(45),
specialtyEquipment VARCHAR2(25),
-- Table-level constraints
CONSTRAINT specialty_specialtyid_pk PRIMARY KEY (specialtyid),
CONSTRAINT specialty_specequipment_ck
    CHECK (
        UPPER(specialtyequipment) IN ('NONE', 'LITE', 'MEDIUM', 'HEAVY')));

-- POPULATE CIR_SPECIALTY
INSERT INTO CIR_specialty VALUES ( 100, 'Contortionist', 'Amaze', 'NONE');
INSERT INTO CIR_specialty VALUES ( 200, 'Singer', 'Musical', 'LITE');
INSERT INTO CIR_specialty VALUES ( 300, 'Clown', 'Humor', 'HEAVY');
INSERT INTO CIR_specialty VALUES ( 400, 'Athlete', 'Body', 'LITE');
INSERT INTO CIR_specialty VALUES ( 500, 'Dancer', 'Body', 'NONE');
INSERT INTO CIR_specialty VALUES ( 600, 'Instrumentalist', 'Musical', 'NONE');
INSERT INTO CIR_specialty VALUES ( 700, 'Actor', 'Body', 'NONE');
INSERT INTO CIR_specialty VALUES ( 800, 'Slackline', 'Amaze', 'Medium');
INSERT INTO CIR_specialty VALUES ( 900, 'Martial Artist', 'Body', 'Medium');
INSERT INTO CIR_specialty VALUES ( 1000, 'Trapeze', 'Amaze', 'Heavy');
INSERT INTO CIR_specialty VALUES ( 1100, 'Juggler', 'Amaze', 'Medium');



--------------------
-- CIR_Performer
CREATE TABLE CIR_PERFORMER (
performerID         NUMBER(6),
performerNickName   VARCHAR2(35),
performerFirstName  VARCHAR2(25),
performerLastName   VARCHAR2(25),
performerBirthDate  DATE,
performerspecialtyLevel NUMBER(1),
specialtyID         NUMBER(4),
teamID             NUMBER(4),
-- Table-level constraints
CONSTRAINT performer_performerid_pk PRIMARY KEY (performerid),
CONSTRAINT performer_specialtyid_fk FOREIGN KEY (specialtyid)   REFERENCES CIR_specialty(specialtyid),
CONSTRAINT team_teamid_fk           FOREIGN KEY (teamid)        REFERENCES CIR_team(teamid));
    
-- POPULATE CIR_PERFORMER
INSERT INTO CIR_performer VALUES (
1, 'Long-finned pilot whale', 'Reinold', 'Timblett', TO_DATE('15-Oct-1989', 'DD-Mon-YYYY'), 1, 600, 700);
INSERT INTO CIR_performer VALUES (
2, 'Cat, tiger', 'Kalinda', 'Hanburry', TO_DATE('31-Oct-1993', 'DD-Mon-YYYY'), 7, 1000, 700);
INSERT INTO CIR_performer VALUES (
3, 'Skink, blue-tongued', 'Salvador', 'Agnolo', TO_DATE('13-Apr-1988', 'DD-Mon-YYYY'), 9, 1000, 700);
INSERT INTO CIR_performer VALUES (
4, 'Grenadier, purple', 'Lula', 'Hellings', TO_DATE('15-Apr-1986', 'DD-Mon-YYYY'), 5, 1100, 600);
INSERT INTO CIR_performer VALUES (
5, 'Sandpiper, spotted wood', 'Urbano', 'Hirsch', TO_DATE('21-Feb-1988', 'DD-Mon-YYYY'), 0, 1000, 800);
INSERT INTO CIR_performer VALUES (
6, 'Lizard, blue-tongued', 'Pedro', 'Darragh', TO_DATE('21-Oct-1995', 'DD-Mon-YYYY'), 9, 900, 800);
INSERT INTO CIR_performer VALUES (
7, 'Polecat, african', 'Bonita', 'Dominguez', TO_DATE('11-Jun-1998', 'DD-Mon-YYYY'), 0, 700, 800);
INSERT INTO CIR_performer VALUES (
8, 'Lesser masked weaver', 'Neal', 'Ell', TO_DATE('17-May-1996', 'DD-Mon-YYYY'), 9, 1000, 100);
INSERT INTO CIR_performer VALUES (
9, 'Gecko, bent-toed', 'Issie', 'Norree', TO_DATE('30-Apr-1990', 'DD-Mon-YYYY'), 8, 1000, 600);
INSERT INTO CIR_performer VALUES (
10, 'Bateleur eagle', 'Amanda', 'Drynan', TO_DATE('03-Feb-1985', 'DD-Mon-YYYY'), 0, 1000, 100);
INSERT INTO CIR_performer VALUES (
11, 'Avocet, pied', 'Myra', 'Krolik', TO_DATE('20-Jun-1999', 'DD-Mon-YYYY'), 6, 900, 800);
INSERT INTO CIR_performer VALUES (
12, 'Smith''s bush squirrel', 'Willi', 'Quinane', TO_DATE('19-Nov-1995', 'DD-Mon-YYYY'), 0, 1000, 600);
INSERT INTO CIR_performer VALUES (
13, 'White-bellied sea eagle', 'Joy', 'Canniffe', TO_DATE('13-May-1987', 'DD-Mon-YYYY'), 3, 600, 700);
INSERT INTO CIR_performer VALUES (
14, 'Black-footed ferret', 'Starr', 'Berkely', TO_DATE('04-Mar-1998', 'DD-Mon-YYYY'), 9, 800, 600);
INSERT INTO CIR_performer VALUES (
15, 'Stork, marabou', 'Walker', 'Symcoxe', TO_DATE('23-Jul-1999', 'DD-Mon-YYYY'), 6, 1000, 800);

   
--------------------
-- CIR_EVENT
CREATE TABLE CIR_EVENT (
eventID     NUMBER(10),
showID      NUMBER(4),
locationID  NUMBER(4),
eventDate   DATE CONSTRAINT event_eventdate_nn NOT NULL,
-- Table-level constraints
CONSTRAINT event_eventid_pk PRIMARY KEY (eventid),
CONSTRAINT event_showid_fk     FOREIGN KEY (showid)     
             REFERENCES CIR_show(showid),
CONSTRAINT event_locationid_fk FOREIGN KEY (locationid) 
             REFERENCES CIR_location(locationid));

-- POPULATE CIR_EVENT
INSERT INTO CIR_event VALUES (1, 10, 101, '28-Jun-2019');
INSERT INTO CIR_event VALUES (2, 10, 101, '28-Sep-2011');
INSERT INTO CIR_event VALUES (3, 10, 202, '27-Jun-2012');
INSERT INTO CIR_event VALUES (4, 10, 303, '06-Feb-2015');
INSERT INTO CIR_event VALUES (5, 50, 101, '29-May-2016');
INSERT INTO CIR_event VALUES (6, 10, 101, '29-May-2017');
INSERT INTO CIR_event VALUES (7, 10, 202, '08-May-2018');
INSERT INTO CIR_event VALUES (8, 10, 505, '31-Oct-2019');
INSERT INTO CIR_event VALUES (9, 10, 606, '12-Feb-2018');
INSERT INTO CIR_event VALUES (10, 40, 404, '19-Jan-2018');
INSERT INTO CIR_event VALUES (11, 30, 606, '22-Oct-2018');
INSERT INTO CIR_event VALUES (12, 40, 606, '15-Oct-2019');
INSERT INTO CIR_event VALUES (13, 30, 606, '06-May-2018');
INSERT INTO CIR_event VALUES (14, 40, 202, '11-Nov-2019');

--------------------
-- CIR_EVENT_has_performers
CREATE TABLE CIR_EVENT_has_performers (
eventID     NUMBER(10),
performerID NUMBER(4),
-- Table-level constraints
CONSTRAINT CIR_ehc_pk PRIMARY KEY (eventID, performerID),
CONSTRAINT ehp_eventid_fk     FOREIGN KEY (eventid)     REFERENCES CIR_event(eventid),
CONSTRAINT ehp_performerid_fk FOREIGN KEY (performerid) REFERENCES CIR_performer(performerid));

-- POPULATE CIR_EVENT_has_performers
INSERT INTO CIR_event_has_performers VALUES (1, 1);
INSERT INTO CIR_event_has_performers VALUES (1, 2);
INSERT INTO CIR_event_has_performers VALUES (1, 3);
INSERT INTO CIR_event_has_performers VALUES (1, 4);
INSERT INTO CIR_event_has_performers VALUES (1, 5);
INSERT INTO CIR_event_has_performers VALUES (1, 6);
INSERT INTO CIR_event_has_performers VALUES (1, 7);
INSERT INTO CIR_event_has_performers VALUES (1, 8);
INSERT INTO CIR_event_has_performers VALUES (1, 9);
INSERT INTO CIR_event_has_performers VALUES (1, 10);
INSERT INTO CIR_event_has_performers VALUES (2, 1);
INSERT INTO CIR_event_has_performers VALUES (2, 2);
INSERT INTO CIR_event_has_performers VALUES (2, 3);
INSERT INTO CIR_event_has_performers VALUES (2, 14);
INSERT INTO CIR_event_has_performers VALUES (2, 15);
INSERT INTO CIR_event_has_performers VALUES (3, 1);
INSERT INTO CIR_event_has_performers VALUES (3, 4);
INSERT INTO CIR_event_has_performers VALUES (3, 8);
INSERT INTO CIR_event_has_performers VALUES (3, 9);
INSERT INTO CIR_event_has_performers VALUES (3, 10);
INSERT INTO CIR_event_has_performers VALUES (1, 12);
INSERT INTO CIR_event_has_performers VALUES (1, 13);
INSERT INTO CIR_event_has_performers VALUES (4, 3);
INSERT INTO CIR_event_has_performers VALUES (4, 4);
INSERT INTO CIR_event_has_performers VALUES (4, 5);
INSERT INTO CIR_event_has_performers VALUES (4, 6);
INSERT INTO CIR_event_has_performers VALUES (7, 1);

--------------------
-- CIR_EVENT_has_CUSTOMERS
CREATE TABLE CIR_EVENT_has_CUSTOMERS (
eventID     NUMBER(10),
customerID  NUMBER(4),
-- Table-level constraints
CONSTRAINT ehc_pk PRIMARY KEY (eventID, customerID),
CONSTRAINT ehc_eventid_fk    FOREIGN KEY (eventid)    REFERENCES CIR_event(eventid),
CONSTRAINT ehc_customerid_fk FOREIGN KEY (customerid) REFERENCES CIR_customer(customerid));

-- POPULATE CIR_EVENT_has_Customers
INSERT INTO CIR_event_has_customers VALUES (1, 1);
INSERT INTO CIR_event_has_customers VALUES (1, 2);
INSERT INTO CIR_event_has_customers VALUES (1, 5);
INSERT INTO CIR_event_has_customers VALUES (1, 6);
INSERT INTO CIR_event_has_customers VALUES (2, 3);
INSERT INTO CIR_event_has_customers VALUES (2,12);
INSERT INTO CIR_event_has_customers VALUES (4, 4);
INSERT INTO CIR_event_has_customers VALUES (5, 5);
INSERT INTO CIR_event_has_customers VALUES (5, 6);
INSERT INTO CIR_event_has_customers VALUES (5, 7);
INSERT INTO CIR_event_has_customers VALUES (5, 8);
INSERT INTO CIR_event_has_customers VALUES (5, 9);
INSERT INTO CIR_event_has_customers VALUES (5, 10);
INSERT INTO CIR_event_has_customers VALUES (2, 6);
INSERT INTO CIR_event_has_customers VALUES (1, 7);
INSERT INTO CIR_event_has_customers VALUES (3, 13);
INSERT INTO CIR_event_has_customers VALUES (3, 12);
INSERT INTO CIR_event_has_customers VALUES (3, 6);
INSERT INTO CIR_event_has_customers VALUES (3, 8);
INSERT INTO CIR_event_has_customers VALUES (9, 11);
INSERT INTO CIR_event_has_customers VALUES (9, 10);
INSERT INTO CIR_event_has_customers VALUES (2, 5);
INSERT INTO CIR_event_has_customers VALUES (4, 7);
INSERT INTO CIR_event_has_customers VALUES (4, 2);
INSERT INTO CIR_event_has_customers VALUES (4, 13);
INSERT INTO CIR_event_has_customers VALUES (4, 10);
INSERT INTO CIR_event_has_customers VALUES (12, 7);
INSERT INTO CIR_event_has_customers VALUES (6, 14);
commit;
